package flightbooking.data;

import java.util.Hashtable;

/**
 * This class represents a table of distances between different cities.
 * It is used by the <code>DistanceManager</code>
 * to store and retrieve those distances.
 */
public class DistanceTable {
	public final static int NO_DISTANCE = 0;

	private Hashtable _data = new Hashtable();

	/**
	 * A list of distances.
	 */
	public class DistanceList {
		private Hashtable _distances = new Hashtable();

		public void addDistance(String placeName, int distance) {
			_distances.put(placeName, new Integer(distance));
		}

		public int getDistance(String placeName) {
			return _distances.containsKey(placeName) ? ((Integer) _distances
					.get(placeName)).intValue() : NO_DISTANCE;
		}
	}

	public DistanceTable() {
		super();
	}

	public void addPlace(String name) {
		_data.put(name, new DistanceList());
	}

	public DistanceList getPlaceDistances(String name) {
		return (DistanceList) _data.get(name);
	}

	public boolean containsPlace(String name) {
		return _data.containsKey(name);
	}
}