package flightbooking.model;

import java.util.Enumeration;
import java.util.Hashtable;

import flightbooking.model.Passenger;

/**
 * This class implements a list of <code>Passenger</code>s.
 */
public class PassengerDB {
    
	private Hashtable _data;
	private Enumeration _valueEnumeration;
	
	public PassengerDB() {
		_data = new Hashtable();
	}

	public void add(Passenger pass) {
		if (!_data.containsKey(pass.getName())) {
			_data.put(pass.getName(), pass);
		}
	}

	public void remove(Passenger pass) {
		_data.remove(pass.getName());
	}

	public Passenger get(String name) {
		return (Passenger) _data.get(name);
	}

	public boolean contains(String name) {
		return _data.containsKey(name);
	}
	
	
	public void reset() {
		_valueEnumeration = _data.elements();
	}
	
	public boolean hasNext() {
		return _valueEnumeration != null && _valueEnumeration.hasMoreElements();
	}
	
	public Passenger getNext() {
		return (Passenger)_valueEnumeration.nextElement();
	}
}