package flightbooking.util;

import java.util.Vector;
import java.util.Enumeration;

import flightbooking.model.Flight;
import flightbooking.util.FlightIterator;

/**
 * This class implements a list of <code>Flight</code>s.
 */
public class FlightList {
	private Vector _data;

	public FlightList() {
		_data = new Vector();
	}

	public void add(Flight flight) {
		if (!_data.contains(flight)) {
			_data.add(flight);
		}
	}

	public void remove(Flight flight) {
		_data.remove(flight);
	}

	public Flight get(int idx) {
		return (Flight) _data.get(idx);
	}

	public FlightIterator getIterator() {
		final Enumeration rawIter = _data.elements();

		return new FlightIterator() {

			public boolean hasNext() {
				return rawIter.hasMoreElements();
			}

			public Flight getNext() {
				return (Flight) rawIter.nextElement();
			}

			public int getLength() {
				return _data.size();
			}
		};
	}
}