package flightbooking.util;

import java.util.Vector;
import java.util.Iterator;

import flightbooking.model.Segment;

/**
 * This class implements a list of <code>Segment</code>s.
 */
public class SegmentList
{
	private Vector _data;

	public SegmentList()
	{
		 _data = new Vector();
	}
	
	public void add(Segment seg)
	{
		if (!_data.contains(seg))
		{
			_data.add(seg);
		}
	}

	public void remove(Segment seg)
	{
		_data.remove(seg);
	}

	public Segment get(int idx)
	{
		return (Segment)_data.elementAt(idx);
	}

	public SegmentIterator getIterator()
	{
		final Iterator rawIter = _data.iterator();

		return new SegmentIterator()
		{

			public boolean hasNext()
			{
				return rawIter.hasNext();
			}

			public Segment getNext()
			{
				return (Segment)rawIter.next();
			}
		};
	}
}
